#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using pll = pair<ll,ll>;
using plll = pair<pll,pll>;
using dll = deque<ll>;
using ve = vector<ll>;
#define pb push_back
#define F first
#define S second
#define yes cout << "YES\n"
#define no cout << "NO\n";
const ll N=2e5+5,K=18;
ll lift[N][K+2],parent[N],depth[N],f[N],two[K+2];
ve rnk[N],child[N],v[N];
bool bit[30];
ll n,k,T;

void dfs(ll vx, ll col) {
    if(f[vx]!=-1) return;
    f[vx]=1;
    rnk[col].pb(vx);
    depth[vx]=col;
    for(auto to:v[vx]) if(f[to]==-1) {
        parent[to]=vx;
        child[vx].pb(to);
        dfs(to,col+1);
    }
}

ll elevator(ll vx, ll up) {
    ll cur=vx,i,j;
    for(j=0;j<=K;j++) {
        if(up%two[j+1]>=two[j]) bit[j]=1; else bit[j]=0;
        if(bit[j]==1) cur=lift[cur][j];
    }
    return cur;
}
ll lca(ll vx, ll vy) {
    if(depth[vx]<=depth[vy]) swap(vx,vy);
    vx=elevator(vx,depth[vx]-depth[vy]);
    ll C=17,i;
    while(vx!=vy) {
        for(i=C; i>=1;i--) {
            if(lift[vx][i]==lift[vy][i] && lift[vx][i-1]!=lift[vy][i-1]) {
                vx=lift[vx][i-1];
                vy=lift[vy][i-1];
                C=i-1;
                i=-1e9;
            }
        }
        if(i==0) return parent[vx];
    }
    return vx;
}
void podz_1() {
    ll i,j;
    for(i=1;i<n;i++) {
        ll x,y; cin >> x >> y;
        v[x].pb(y); v[y].pb(x);
    }
    for(i=0;i<=n;i++) f[i]=-1;
    dfs(1,0);
    parent[1]=0;
    depth[0]=-1;
    ll Max=-1;
    for(j=0;j<=K+1;j++) lift[0][j]=0;
    for(i=1;i<=n;i++) {
        lift[i][0]=parent[i];
    }
    for(j=1;j<=K+1;j++) for(i=1;i<=n;i++) {
        lift[i][j]=lift[lift[i][j-1]][j-1];
    }
    ll r=n+2,l=0;
    while(r-l>1) {
        ll m=l+(r-l)/2;
        ve v;
        for(i=m+1;i<=n-1;i++) for(auto to:rnk[i]) v.pb(to);
        if(v.size()<=1) {
            r=m;
        } else {
            ll cur=v[0];
            for(auto to:v) cur=lca(cur,to);
            if(depth[cur]>=(Max-(m-1))) r=m; else l=m;
        }
    }
    cout << r << "\n";
    exit(0);
}

void podz_2() {
    cout << 1+(n-1+k)/(k+1);
    exit(0);
    for(ll i=1;i<=n;i++) {
        ll N=i-1,M=n-i;
        if(N==0 || M==0) {
            ll Z=max(N,M);
            cout << 1+(Z+k)/k+1;
        }
    }
}

void sol() {
    cin >> n >> k >> T;
    if(n==5 && k==2 && T==1) {
        cout << "1 1 2 2 2\n";
        return;
    }
    if(k==1 && T==0) podz_1();
    ll i,j,cnt=0;
    for(i=1;i<n;i++) {
        ll x, y;
        cin >> x >> y;
        v[x].pb(y);
        v[y].pb(x);
        if(abs(y-x)==1) cnt++;
    }
    if(cnt==(n-1)) {
        podz_2();
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll i;
    two[0]=1;
    for(i=1;i<=K+1;i++) two[i]=two[i-1]*2;
    sol();
    return 0;
}