#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using pll = pair<ll,ll>;
using plll = pair<pll,pll>;
using dll = deque<ll>;
using ve = vector<ll>;
#define pb push_back
#define F first
#define S second
#define yes cout << "YES\n"
#define no cout << "NO\n";
const ll N=2e5+5,K=18;
ll lift[N][K+2],parent[N],depth[N],f[N],two[K+2];
ve rnk[N],child[N],v[N];
bool bit[30];
ll n,k,T;

void dfs(ll vx, ll col) {
    if(f[vx]!=-1) return;
    f[vx]=1;
    rnk[col].pb(vx);
    depth[vx]=col;
    for(auto to:v[vx]) if(f[to]==-1) {
            parent[to]=vx;
            child[vx].pb(to);
            dfs(to,col+1);
        }
}

ll elevator(ll vx, ll up) {
    ll cur=vx,i,j;
    for(j=0;j<=K;j++) {
        if(up%two[j+1]>=two[j]) bit[j]=1; else bit[j]=0;
        if(bit[j]==1) cur=lift[cur][j];
    }
    return cur;
}
ll lca(ll vx, ll vy) {
    if(depth[vx]<=depth[vy]) swap(vx,vy);
    vx=elevator(vx,depth[vx]-depth[vy]);
    ll C=17,i;
    while(vx!=vy) {
        for(i=C; i>=1;i--) {
            if(lift[vx][i]==lift[vy][i] && lift[vx][i-1]!=lift[vy][i-1]) {
                vx=lift[vx][i-1];
                vy=lift[vy][i-1];
                C=i-1;
                i=-1e9;
            }
        }
        if(i==0) return parent[vx];
    }
    return vx;
}

void podz_1() {
    ll i,j;
    for(i=1;i<n;i++) {
        ll x,y; cin >> x >> y;
        v[x].pb(y); v[y].pb(x);
    }
    for(i=0;i<=n;i++) f[i]=-1;
    dfs(1,0);
    parent[1]=0;
    depth[0]=-1;
    ll Max=-1;
    for(i=1;i<=n;i++) Max=max(Max,depth[i]);
//    for(i=1;i<=n;i++) cout << depth[i] << " ";
//    cout << "\n";

    // lca
    for(j=0;j<=K+1;j++) lift[0][j]=0;
    for(i=1;i<=n;i++) {
        lift[i][0]=parent[i];
    }
    for(j=1;j<=K+1;j++) for(i=1;i<=n;i++) {
            lift[i][j]=lift[lift[i][j-1]][j-1];
        }
    ll r=n+2,l=0;
    while(r-l>1) {
        ll m=l+(r-l)/2;
        ve v;
        for(i=m+1;i<=n-1;i++) for(auto to:rnk[i]) v.pb(to);
        if(v.size()<=1) {
            r=m;
        } else {
            ll cur=v[0];
            for(auto to:v) cur=lca(cur,to);
            if(depth[cur]>=(Max-(m-1))) r=m; else l=m;
        }
    }
    cout << r << "\n";
    exit(0);
}

void podz_2() {
    if(T==0) {
        cout << (n-1+k)/(k+1) << "\n";
        exit(0);
    }
    ll i,j;
    if(k>=n-2) {
        for(i=1;i<=n;i++) cout << "1 ";
        cout << "\n";
        return;
    }
    for(i=1;i<=n;i++) {
        ll N=i-1,M=n-i;
        if(N==0 || M==0) {
            cout << (n-1+k)/(k+1) << " ";
        } else {
            ll l=0,r=n-1;
            while(r-l>1) {
                ll m=l+(r-l)/2;
                ll cur=((N-1)/m)+((M-1)/m);
                if(cur>k) l=m; else r=m;
            }
            cout << r << " ";
        }
    }
    exit(0);
}

ll mx[50];

ll A;
ve vv[20];

void find(ve vk) {
    ll i,j;
    for(i=1;i<=n;i++) vv[i]=v[i];
    for(auto to:vk) {
        vv[A].pb(to);
        vv[to].pb(A);
    }
    for(i=0;i<=n;i++) {
        f[i]=-1;
        depth[i]=n+1;
    }
    ve cur={A};
    depth[A]=0;
    ll nw=0,left=n-1;
    while(left>0) {
        nw++;
        ve neww;
        for(auto to:cur) for(auto next:vv[to]) if(f[next]==-1) {
            f[next]=1;
            left--;
            depth[next]=nw;
            neww.pb(next);
        }
        cur=neww;
    }
    ll mm=-1;
    for(i=1;i<=n;i++) mm=max(mm,depth[i]);
    mx[A]=min(mx[A],mm);
}

void podz_3() {
    ll i,j;
    for(i=1;i<=n;i++) mx[i]=50;
    for(i=1;i<=n;i++) {


        for(ll C=1; C<two[n];C++) {
            for(j=0;j<n;j++) if(C%two[j+1]>=two[j]) bit[j]=1; else bit[j]=0;
            ve vvv;
            for(j=0;j<n;j++) if(bit[j]==1) {
                if((j+1)!=i) vvv.pb(j+1);
            }
            A=i;
           if(vvv.size()==k) find(vvv);
        }
    }
    for(i=1;i<=n;i++) cout << mx[i] << " ";
    cout << "\n";
    exit(0);
}

void sol() {
    cin >> n >> k >> T;
    if(k==1 && T==0) podz_1();
    ll cnt=0;
    for(ll i=1;i<n;i++) {
        ll x,y; cin  >> x >> y;
        v[x].pb(y); v[y].pb(x);
        if(y==x+1) cnt++;
    }
    if(cnt==(n-1)) podz_2();
    if(n<=16) {
        podz_3();
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll i;
    two[0]=1;
    for(i=1;i<=K+1;i++) two[i]=two[i-1]*2;
    sol();
    return 0;
}